//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

bool isfakeuser(const unsigned char* usr) {
#ifdef SERVICES_ENABLED
	if (isfakeservicesuser(usr) == true) {return true;}
#endif
	return false;
}
void sendStartup(int userid) {
	unsigned char response[400];
	snprintf(&response[0],399,":%s NOTICE AUTH :*** Welcome. Send your authentication",cuo.svd);
	response[399] = 0;vsnd(response,userid);
}
void authpong(int userid) {
	unsigned char* r;
	unsigned char response[400];
	if (userpointers[userid]->authpongvalue > 0) {return;}
	if (userpointers[userid]->authed == true) {return;}
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		if (strcasecmp(userpointers[userid]->pass,"") == 0) {
			if (services_userregistered(userpointers[userid]->nickname) == true) {
				snprintf(&response[0],499,":%s 433 AUTH %s :Nickname needs password",cuo.svd,userpointers[userid]->nickname);
				response[499] = 0;vsnd(response,userid);
				strcpy(userpointers[userid]->nickname,"");
				return;
			}
		}else{
			if (services_userregistered(userpointers[userid]->nickname) == true) {
				r = services_upassword(userpointers[userid]->nickname);
				if (r == NULL) {
					snprintf(&response[0],499,":%s 433 AUTH %s :The server is currently experiencing a database problem. Renaming to something starting with 'guest' gives you access to the server in every case",cuo.svd,userpointers[userid]->nickname);
					response[499] = 0;vsnd(response,userid);
					strcpy(userpointers[userid]->nickname,"");
					return;
				}else{
					if (strcasecmp(r,"") != 0) {
						if (strcasecmp(userpointers[userid]->pass,r) != 0) {
							snprintf(&response[0],499,"ERROR :Closing link: Password for %s is wrong",userpointers[userid]->nickname);
							response[499] = 0;vsnd(response,userid);
							userQuit(userid,USERQUIT_ERROR);
							return;
						}else{
							//set registered flag
							userpointers[userid]->accountname = malloc(strlen(userpointers[userid]->nickname) + 1);
							if (userpointers[userid]->accountname == NULL) {
								snprintf(&response[0],499,":%s 433 AUTH %s :The server is currently experiencing a memory allocation problem. Renaming to something starting with 'guest' gives you access to the server in every case",cuo.svd,userpointers[userid]->nickname);
								response[499] = 0;vsnd(response,userid);
								strcpy(userpointers[userid]->nickname,"");
								return;
							}
							strcpy(userpointers[userid]->accountname,userpointers[userid]->nickname);
							snprintf(&response[0],499,":%s NOTICE %s :*** You are now logged in (NickServ)",cuo.svd,userpointers[userid]->nickname);
							response[499] = 0;vsnd(response,userid);
						}
					}
				}
			}
		}
	}
#endif
	long l = time(NULL);
	userpointers[userid]->authpongvalue = l;
	snprintf(&response[0],399,"PING :%ld",l);
	response[399] = 0;
	vsnd(response,userid);
	return;
}
unsigned char getchannelmodes_staticbuffer[500];
unsigned char* GetChannelModes(int chanid, bool outside) {
	char tempstr[PROCESSLENGTH];
	strcpy(getchannelmodes_staticbuffer,"n\0");
	if (chans[chanid]->mode_blockcolours == true) {strcat(getchannelmodes_staticbuffer,"c\0");}
	if (chans[chanid]->mode_moderated == true) {strcat(getchannelmodes_staticbuffer,"m\0");}
	if (chans[chanid]->mode_private == true) {strcat(getchannelmodes_staticbuffer,"s\0");}
	if (chans[chanid]->mode_topiclock == true) {strcat(getchannelmodes_staticbuffer,"t\0");}
	if (chans[chanid]->mode_registered == true) {strcat(getchannelmodes_staticbuffer,"r\0");}
	if (chans[chanid]->mode_inviteonly == true) {strcat(getchannelmodes_staticbuffer,"i\0");}
	if (chans[chanid]->userlimit > 0) {strcat(getchannelmodes_staticbuffer,"l\0");}
	if (chans[chanid]->password != 0) {strcat(getchannelmodes_staticbuffer,"k\0");}
	if (chans[chanid]->userlimit > 0 && outside == false) {sprintf(&tempstr[0]," %d",chans[chanid]->userlimit);strcat(getchannelmodes_staticbuffer,tempstr);}
	if (chans[chanid]->password != 0 && outside == false) {strcat(getchannelmodes_staticbuffer," ");strcat(getchannelmodes_staticbuffer,chans[chanid]->password);}
	return getchannelmodes_staticbuffer;
}
void makeuseridvalid(unsigned char* userid) {
	unsigned char neu[20] = "";
	if (strlen(userid) < 1) {
		strcpy(userid,"");
		return;
	}
	int fcount2;
	bool isokay;
	fcount2 = 0;
	while (fcount2 <= strlen(userid) - 1 && strlen(neu) < 9 && fcount2 < 20) {
		isokay = false;
		if (userid[fcount2] >= 65 && userid[fcount2] <= 90) {//big letters
			isokay = true;
		}
		if (userid[fcount2] >= 97 && userid[fcount2] <= 122) {//small letters
			isokay = true;
		}
		if (userid[fcount2] >= 48 && userid[fcount2] <= 57) {//numbers
			isokay = true;
		}
		if (userid[fcount2] == 95 && fcount2 >= 1) {//underlined _ - NOT AT THE BEGINNING
			isokay = true;
		}
		if (isokay == true) {neu[strlen(neu)+1] = 0;neu[strlen(neu)] = userid[fcount2];}
		fcount2 += 1;
	}
	strcpy(userid,neu);
}
bool nicknamevalid(char* nick) {
	if (strlen(nick) < 1) {
		return false;
	}
	int fcount2;
	int charcount;
	charcount = 0;
	bool isokay;
	fcount2 = 0;
	while (fcount2 <= strlen(nick) - 1) {
		isokay = false;
		if (nick[fcount2] >= 65 && nick[fcount2] <= 90) {//big letters
			isokay = true;charcount += 1;
		}
		if (nick[fcount2] >= 97 && nick[fcount2] <= 122) {//small letters
			isokay = true;charcount += 1;
		}
		if (nick[fcount2] >= 48 && nick[fcount2] <= 57 && fcount2 >= 1) {//numbers - NOT AT THE BEGINNING
			isokay = true;
		}
		if (nick[fcount2] == '_' || nick[fcount2] == '^' || nick[fcount2] == '|' || nick[fcount2] == '[' || nick[fcount2] == ']' || nick[fcount2] == '(' || nick[fcount2] == ')' || nick[fcount2] == '-') {//special chars
			isokay = true;
		}
		if (isokay == false) {return false;}
		fcount2 += 1;
	}
	if (charcount <= 0) {return false;}
	return true;
}
bool nickused(const unsigned char* nick) {
	if (strlen(nick) < 1) {return false;}
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (strcasecmp(userpointers[r]->nickname,nick) == 0) {
				return true;
			}
		}
		r += 1;
	}
	return false;
}
void notenoughparameters(int userid, const unsigned char* command) {
	unsigned char send[400];
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		snprintf(&send[0],399,":%s 461 %s %s :Not enough parameters",currentoptions.serverdomain,userpointers[userid]->nickname,command);
	}else{
		snprintf(&send[0],399,":%s 461 %s %s :Not enough parameters",currentoptions.serverdomain,"AUTH",command);
	}
	send[399] = 0;
	vsnd(send,userid);
}
void sendwhois(int userid,int targetid) {
	unsigned char send[501];
	snprintf(&send[0],499,":%s 311 %s %s %s %s * :%s",cuo.svd,un(userid),un(targetid),userpointers[targetid]->suserid,userpointers[targetid]->host,userpointers[targetid]->realname);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 312 %s %s %s :%s",cuo.svd,un(userid),un(targetid),cuo.svd,cuo.svd);
	send[499] = 0;vsnd(send,userid);
	if (userpointers[targetid]->ircop == true) {
		snprintf(&send[0],499,":%s 313 %s %s :is an IRC operator",cuo.svd,un(userid),un(targetid));
		send[499] = 0;vsnd(send,userid);
	}
	if (userpointers[targetid]->accountname != NULL) {
		snprintf(&send[0],499,":%s 320 %s %s :is identified as %s",cuo.svd,un(userid),un(targetid),userpointers[targetid]->accountname);
		send[499] = 0;vsnd(send,userid);
	}
	snprintf(&send[0],499,":%s 318 %s %s :End of /WHOIS",cuo.svd,un(userid),un(targetid));
	send[499] = 0;vsnd(send,userid);
}
int usercount() {
	int r = 0;
	int k = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->pleaseremove == false && userpointers[r]->authed == true) {
				k += 1;
			}
		}
		r += 1;
	}
	return k;
}
int max_ucount;
void sendlusers(int userid) {
	unsigned char send[501];
	int ucount = usercount();
	#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		ucount += 4;
	}
	#endif
	if (ucount > max_ucount) {max_ucount = ucount;}
	snprintf(&send[0],499,":%s 265 %s :Current local users: %d  Max: %d",cuo.svd,un(userid),ucount,max_ucount);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 266 %s :Current global users: %d  Max: %d",cuo.svd,un(userid),ucount,max_ucount);
	send[499] = 0;vsnd(send,userid);
}
void sendwho(int chan, int user, int targetuser) {
	//:zelazny.freenode.net 352 Yarcanox #devurandom n=JPT star-sim.de irc.freenode.net JPT G :0 Jan Philipp Timme
	unsigned char channame[500];
	if (chan >= 0) {
		strncpy(channame,chans[chan]->name,499);
		channame[499] = 0;
	}else{
		strcpy(channame,"*");
	}
	unsigned char flags[5] = "";
	if (userpointers[user]->awayreason == NULL) {
		strcpy(flags,"H");
	}else{
		if (strcasecmp(userpointers[user]->awayreason,"") == 0) {
			strcpy(flags,"H");
		}else{
			strcpy(flags,"G");
		}
	}
	if (userpointers[user]->ircop == true) {
		strcat(flags,"*");
	}
	if (chan >= 0) {
		if (isoponchan(user,chan) == true) {
			strcat(flags,"@");
		}else{
			if (ishoponchan(user,chan) == true) {
				strcat(flags,"%");
			}else{
				if (isvoiceonchan(user,chan) == true) {
					strcat(flags,"+");
				}else{
					
				}
			}
		}
	}
	unsigned char response[500];
	snprintf(&response[0],499,":%s 352 %s %s %s %s %s %s %s :0 %s",cuo.svd,un(targetuser),channame,userpointers[user]->suserid,userpointers[user]->host,cuo.svd,un(user),flags ,userpointers[user]->realname);
	response[499] = 0;vsnd(response,targetuser);
}
void authdone(int userid) {
	unsigned char send[501];
	userpointers[userid]->ping_lastping = time(NULL);
	userpointers[userid]->authed = true;
	snprintf(&send[0],499,":%s 001 %s :Welcome to %s %s",cuo.svd,un(userid),cuo.networkname,un(userid));
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 002 %s :Your host is %s, running WeIRCd%s",cuo.svd,un(userid),cuo.svd,bigversion);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s NOTICE %s :*** Your host is %s, running WeIRCd%s",cuo.svd,un(userid),cuo.svd,bigversion);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 003 %s :This server was created on a rainy monday",cuo.svd,un(userid));
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 004 %s :%s WeIRCd%s iows bcihklmnOostv",cuo.svd,un(userid),cuo.svd,bigversion);
	snprintf(&send[0],499,":%s 005 %s CHANTYPES=# PREFIX=(ohv)@%c+ NETWORK=%s :are supported by this server",cuo.svd,un(userid),'%',cuo.networkname);
	send[499] = 0;vsnd(send,userid);
	snprintf(&send[0],499,":%s 005 %s CHANLIMIT=#:%d IRCD=WeIRCd NICKLEN=%d CASEMAPPING=ascii USERLEN=9 :are supported by this server",cuo.svd,un(userid),cuo.vmaxchansperuser,COMPILEOPTION_MAXNICKLEN);
	send[499] = 0;vsnd(send,userid);
	sendlusers(userid);
	motd_send(userid);
}
void sendversion(int r) {
	unsigned char send[501];
	snprintf(&send[0],499,":%s 351 %s WeIRCd%s subvers%s :",cuo.svd,un(r),bigversion,version_detail,cuo.svd);
	vsnd(send,r);
}
bool isvalidchanname(const unsigned char* channame) {
	int r = 0;
	while (r < strlen(channame)) {
		if (channame[r] == '#' || (channame[r] >= 'a' && channame[r] <= 'z') || (channame[r] >= 'A' && channame[r] <= 'Z') || (channame[r] >= '0' && channame[r] <= '9') || channame[r] == '_' || channame[r] == '-' || channame[r] == '.' || channame[r] == ':' || channame[r] == '!' || channame[r] == '/' || channame[r] == '\\' || channame[r] == '[' || channame[r] == ']' || channame[r] == '(' || channame[r] == ')' || channame[r] == '?' || channame[r] == '+' || channame[r] == '*' || channame[r] == '<' || channame[r] == '>' || channame[r] == ';') {
			
		}else{
			return false;
		}
		r += 1;
	}
	return true;
}
void sendchanusers(int user,int chan) {
	unsigned char sendbase[501];
	snprintf(&sendbase[0],499,":%s 353 %s = %s :",cuo.svd,un(user),chans[chan]->name);
	sendbase[499] = 0;
	unsigned char send[501];
	unsigned char pref;
	int r = 0;
	int c = 0;
	strcpy(send,sendbase);
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		if (chanregistered(chans[chan]->name) == true) {
			strcat(send,"@ChanServ");
			c++;
		}
	}
#endif
	while (r < userslotcount) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->authed == true && userpointers[r]->pleaseremove == false) {
				if (isuserinchan(r,chan) == true) {
					if (strlen(send) + strlen(un(r)) + 2 < 499) {
						c += 1;
						if (c > 1) {strcat(send," ");}
						pref = userprefix(r,chan);
						if (pref != 0) {send[strlen(send)+1] = 0;send[strlen(send)] = pref;}
						strcat(send,un(r));
					}else{
						vsnd(send,user);
						strcpy(send,sendbase);
						pref = userprefix(r,chan);
						if (pref != 0) {send[strlen(send)+1] = 0;send[strlen(send)] = pref;}
						strcat(send,un(r));
						c = 1;
					}
				}
			}
		}
		r += 1;
	}
	if (c > 0) {vsnd(send,user);}
	snprintf(&send[0],499,":%s 366 %s %s :End of /NAMES list",cuo.svd,un(user),chans[chan]->name);
	send[499] = 0;
	vsnd(send,user);
}
void sendtopic(int user,int chan) {
	unsigned char send[501];
	if (chans[chan]->topic_settime > 0) {//gibtn topic
		snprintf(&send[0],499,":%s 332 %s %s :%s",cuo.svd,un(user),chans[chan]->name,chans[chan]->topic);
		send[499] = 0;
		vsnd(send,user);
		snprintf(&send[0],499,":%s 333 %s %s %s %d",cuo.svd,un(user),chans[chan]->name,chans[chan]->topic_setby,chans[chan]->topic_settime);
		send[499] = 0;
		vsnd(send,user);return;
	}else{//gibt kein topic
		snprintf(&send[0],499,":%s 331 %s %s :No topic is set",cuo.svd,un(user),chans[chan]->name);
		send[499] = 0;
		vsnd(send,user);
	}
}
void moveoutofchan(int user,const unsigned char* channame, const unsigned char* reason) {
	unsigned char lclchanname[200];
	unsigned char send[501];
	strncpy(lclchanname,channame,199);lclchanname[199] = 0;
	trimleft(lclchanname);cutonfirstspace(lclchanname);
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	int r;
	int k = 0;
	k = getChanID(lclchanname);
	if (k < 0) {
		snprintf(&send[0],499,":%s 442 %s %s :You are not in this channel",cuo.svd,un(user),lclchanname);
		send[499] = 0;
		vsnd(send,user);
		return;
	}else{
		if (isuserinchan(user,k) == false) {
			snprintf(&send[0],499,":%s 442 %s %s :You are not in this channel",cuo.svd,un(user),lclchanname);
			send[499] = 0;
			vsnd(send,user);
			return;
		}else{
			snprintf(&send[0],499,":%s!%s@%s PART %s :",un(user),userpointers[user]->suserid,userpointers[user]->host,chans[k]->name);
			send[499] = 0;
			tellallusersinchan(send,k);
			r = 0;
			while (r < COMPILEOPTION_MAXCHANSPERUSER) {
				if (userpointers[user]->chan[r] != NULL) {
					if (userpointers[user]->chan[r]->chanid == k) {free(userpointers[user]->chan[r]);userpointers[user]->chan[r] = NULL;}
				}
				r += 1;
			}
			removeemptychans();
		}
	}
}
void moveintochan(int user,const unsigned char* channame) {
	unsigned char lclchanname[200];
	unsigned char send[501];
	strncpy(lclchanname,channame,199);lclchanname[199] = 0;
	trimleft(lclchanname);cutonfirstspace(lclchanname);
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	if (isvalidchanname(lclchanname) == false) {
		snprintf(&send[0],499,":%s 479 %s %s :Illegal channel name",cuo.svd,un(user),lclchanname);
		send[499] = 0;
		vsnd(send,user);
		return;
	}
	if (lclchanname[0] != '#') {
		strcpy(send,"#");strcat(send,lclchanname);
		strncpy(lclchanname,send,199);
		lclchanname[199] = 0;
	}
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	int r = 0;
	int k = -1;
	while (r < COMPILEOPTION_MAXCHANSPERUSER && r < cuo.vmaxchansperuser) {
		if (userpointers[user]->chan[r] == NULL) {k = r;break;}
		r += 1;
	}
	if (k < 0) {//already on too many channels
		snprintf(&send[0],499,":%s 405 %s %s :You are already in too many channels",cuo.svd,un(user),lclchanname);
		send[499] = 0;
		vsnd(send,user);
		return;
	}
	bool iamop = isOppedOnJoin(user,lclchanname);
	r = addChan(lclchanname);
	if (r < 0) {
		snprintf(&send[0],499,":%s 405 %s %s :Global chan limit is full",cuo.svd,un(user),lclchanname);
		send[499] = 0;
		vsnd(send,user);
		return;
	}
	if (isuserinchan(user,r) == true) {
		return;
	}
	userpointers[user]->chan[k] = malloc(sizeof(struct weircd_user_chaninfo));
	if (userpointers[user]->chan[k] == NULL) {
		snprintf(&send[0],499,":%s 400 %s JOIN :Error - out of memory",cuo.svd,un(user));
		send[499] = 0;
		vsnd(send,user);
		return;
	}
	memset(userpointers[user]->chan[k],0,sizeof(struct weircd_user_chaninfo));
	userpointers[user]->chan[k]->chanid = r;
	userpointers[user]->chan[k]->iamop = iamop;
	snprintf(&send[0],499,":%s!%s@%s JOIN %s",userpointers[user]->nickname,userpointers[user]->suserid,userpointers[user]->host,chans[r]->name);
	send[499] = 0;
	tellallusersinchan(send,r);
	if (iamop == true) {
		snprintf(&send[0],499,":ChanServ!services@%s MODE %s +o %s",cuo.serviceshost,chans[r]->name,un(user));
		send[499] = 0;tellallusersinchan_exclude(send,r,user);
	}
	sendtopic(user,r);
	sendchanusers(user,r);
}
void notimplemented(int userid, const unsigned char* command) {
	unsigned char response[501];
	snprintf(&response[0],499,":%s 400 %s %s :%s is not implemented yet",cuo.svd,un(userid),command,command);
	response[499] = 0;
	vsnd(response,userid);
}
#include "weircd_irccommands.c"
void userCMD(int userid, const unsigned char* command, const unsigned char* parameters) {
	unsigned char cmd[40];
	strncpy(cmd,command,39);cmd[39] = 0;
	unsigned char params[520];
	strncpy(params,parameters,519);params[519] = 0;
	unsigned char response[521];
#ifdef SERVICES_ENABLED
	if (cuo.services_activated == 1) {
		if (strcasecmp(cmd,"nickserv") == 0) {
			strcpy(response,params);
			strcpy(params,"NickServ :");
			strncat(params,response,519);
			params[519] = 0;
			strcpy(cmd,"privmsg");
		}
		if (strcasecmp(cmd,"chanserv") == 0) {
			strcpy(response,params);
			strcpy(params,"ChanServ :");
			strncat(params,response,519);
			params[519] = 0;
			strcpy(cmd,"privmsg");
		}
		if (strcasecmp(cmd,"operserv") == 0) {
			strcpy(response,params);
			strcpy(params,"OperServ :");
			strncat(params,response,519);
			params[519] = 0;
			strcpy(cmd,"privmsg");
		}
	}
#endif
#ifdef ACTIVATEDEBUG
	printf(">>[%d] %s %s\n",userid,cmd,params);
#endif
	if (strcasecmp(cmd,"NICK") == 0) {cmd_nick(userid,params);return;}
	if (strcasecmp(cmd,"USER") == 0) {cmd_user(userid,params);return;}
	if (strcasecmp(cmd,"PONG") == 0) {cmd_pong(userid,params);return;}
	if (strcasecmp(cmd,"PRIVMSG") == 0) {userpointers[userid]->floodprotect.floodpoints += 1;cmd_privmsg(userid,params);return;}
	if (strcasecmp(cmd,"LUSERS") == 0) {
		if (x(userid,"LUSERS")) {return;}
		sendlusers(userid);
		return;
	}
	if (strcasecmp(cmd,"VERSION") == 0) {if (x(userid,"VERSION")) {return;}sendversion(userid);return;}
	if (strcasecmp(cmd,"PING") == 0) {cmd_ping(userid,params);return;}
	if (strcasecmp(cmd,"NOTICE") == 0) {userpointers[userid]->floodprotect.floodpoints += 1;cmd_notice(userid,params);return;}
	if (strcasecmp(cmd,"NAMES") == 0) {cmd_names(userid,params);return;}
	if (strcasecmp(cmd,"JOIN") == 0) {cmd_join(userid,params);return;}
	if (strcasecmp(cmd,"PART") == 0) {cmd_part(userid,params);return;}
	if (strcasecmp(cmd,"OPER") == 0) {cmd_oper(userid,params);return;}
	if (strcasecmp(cmd,"KILL") == 0) {cmd_kill(userid,params);return;}
	if (strcasecmp(cmd,"LIST") == 0) {cmd_list(userid,params);return;}
	if (strcasecmp(cmd,"TOPIC") == 0) {cmd_topic(userid,params);return;}
	if (strcasecmp(cmd,"QUIT") == 0) {cmd_quit(userid,params);return;}
	if (strcasecmp(cmd,"WHOIS") == 0) {cmd_whois(userid,params);return;}
	if (strcasecmp(cmd,"MODE") == 0) {cmd_mode(userid,params);return;}
	if (strcasecmp(cmd,"PASS") == 0) {cmd_pass(userid,params);return;}
	if (strcasecmp(cmd,"WHO") == 0) {cmd_who(userid,params);return;}
	if (strcasecmp(cmd,"WHOWAS") == 0) {cmd_whowas(userid,params);return;}
	if (strcasecmp(cmd,"ISON") == 0) {cmd_ison(userid,params);return;}
	userpointers[userid]->floodprotect.floodpoints += 1;
	strupper(cmd);
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		snprintf(&response[0],499,":%s 421 %s %s :Command unknown",cuo.svd,un(userid),cmd);
	}else{
		snprintf(&response[0],499,":%s 421 * %s :Command unknown",cuo.svd,cmd);
	}
	response[499] = 0;
	vsnd(response,userid);
}
